// Hello there, if you were trying to sneak in here.
// That's alright, you can go ahead and use any of the code that was made by me. But make sure to credit me.
// Else your mod will be delisted, as that will broke the MB's rules.
// I hope you have a wonderful time enjoying this character!

freeslot("SPR_FIRE", "SPR_ADRA", "SPR_BDRA", "SPR_NSRK", "SPR_AHSP", "S_PLAY_ALTKLAUGH", "S_PLAY_DIVE", "S_PLAY_DIVEDOWN", "MT_ALTKSPARKLES", "S_ALTKSPARKLE", "MT_HYPERSPARKLES", "S_HYPERFORMSPARKLE", "sfx_punch", "sfx_laugh")

mobjinfo[MT_ALTKSPARKLES] = {
	doomednum = -1,
	spawnstate = S_ALTKSPARKLE,
	deathstate = S_NULL,
	spawnhealth = 999,
	deathsound = sfx_none,
	seesound = sfx_none,
	attacksound = sfx_none,
	painsound = sfx_none,
	activesound = sfx_none,
	painstate = S_NULL,
	speed = 10*FRACUNIT,
	radius = 48*FRACUNIT,
	height = 48*FRACUNIT,
	flags = MF_SCENERY|MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_NOCLIP
}
	
states[S_ALTKSPARKLE] = {
	sprite = SPR_NSRK,
	frame = FF_ANIMATE|FF_SEMIBRIGHT|A,
	tics = 33,
	var1 = 7,
	var2 = 2,
	action = A_None,
	nextstate = S_NULL
}


mobjinfo[MT_HYPERSPARKLES] = {
	doomednum = -1,
	spawnstate = S_HYPERFORMSPARKLE,
	deathstate = S_NULL,
	spawnhealth = 999,
	deathsound = sfx_none,
	seesound = sfx_none,
	attacksound = sfx_none,
	painsound = sfx_none,
	activesound = sfx_none,
	painstate = S_NULL,
	speed = 10*FRACUNIT,
	radius = 48*FRACUNIT,
	height = 48*FRACUNIT,
	flags = MF_SCENERY|MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_NOCLIP
}
	
states[S_HYPERFORMSPARKLE] = {
	sprite = SPR_AHSP,
	frame = FF_ANIMATE|FF_SEMIBRIGHT|A,
	tics = 33,
	var1 = 8,
	var2 = 2,
	action = A_None,
	nextstate = S_NULL
}

states[S_PLAY_DIVE] = {
	sprite = SPR_ADRA,
	frame = FF_ANIMATE,
	tics = 20,
	var1 = 3,
	var2 = 1,
	nextstate = S_PLAY_FALL
}

states[S_PLAY_DIVEDOWN] = {
	sprite = SPR_BDRA,
	frame = FF_ANIMATE,
	tics = 20,
	var1 = 3,
	var2 = 1,
	nextstate = S_PLAY_FALL
}

states[S_PLAY_ALTKLAUGH] = {
	sprite = SPR_FIRE,
	frame = FF_ANIMATE,
	tics = 75,
	var1 = 1,
	var2 = 3,
	nextstate = S_PLAY_STND
}

sfxinfo[sfx_punch].caption = "Punch"
sfxinfo[sfx_laugh].caption = "Laugh"


addHook("PlayerThink", function(p)
	if (p.mo.skin == "altknux")
	and (p.mo.state == S_AIRPUNCH)
	and not (P_IsObjectOnGround(p.mo))
		local ghosteffect = P_SpawnGhostMobj(p.mo)
		ghosteffect.fuse = 3
        ghosteffect.colorized = true
	if p.powers[pw_super]
	and p.knuxhypertrans
		ghosteffect.color = (SKINCOLOR_HYPER1 + abs(((p.powers[pw_super] >> 2) % 9) - 6))
	end	
		ghosteffect.colorized = true
	end	
end)


addHook("PlayerThink", function(p)
	if (p.mo.skin == "altknux")
	and (p.mo.state == S_PLAY_DIVE)
	and not (P_IsObjectOnGround(p.mo))
		local ghosteffect = P_SpawnGhostMobj(p.mo)
		ghosteffect.fuse = 3
        ghosteffect.colorized = true
	if p.powers[pw_super]
	and p.knuxhypertrans
		ghosteffect.color = (SKINCOLOR_HYPER1 + abs(((p.powers[pw_super] >> 2) % 9) - 6))
	end	
		ghosteffect.colorized = true
	end	
end)


addHook("PlayerThink", function(p)
	if (p.mo.skin == "altknux")
	and (p.mo.state == S_PLAY_DIVEDOWN)
	and not (P_IsObjectOnGround(p.mo))
		local ghosteffect = P_SpawnGhostMobj(p.mo)
		ghosteffect.fuse = 3
        ghosteffect.colorized = true
	if p.powers[pw_super]
	and p.knuxhypertrans
		ghosteffect.color = (SKINCOLOR_HYPER1 + abs(((p.powers[pw_super] >> 2) % 9) - 6))
	end	
		ghosteffect.colorized = true
	end	
end)


addHook("PlayerThink", function(p)
	if (p.mo.skin == "altknux")
	and (p.mo.state == S_PUNCH)
	and (P_IsObjectOnGround(p.mo))
		local ghosteffect = P_SpawnGhostMobj(p.mo)
		ghosteffect.fuse = 5
        ghosteffect.colorized = true
	if p.powers[pw_super]
	and p.knuxhypertrans
		ghosteffect.color = (SKINCOLOR_HYPER1 + abs(((p.powers[pw_super] >> 2) % 9) - 6))
	end	
		ghosteffect.colorized = true
	end	
end)

		   
addHook("PlayerThink", function(p)
	if p.mo.skin == "altknux" then
	    if p.isxmomentum
		   p.noxmomchar = 2
		end
		if p.mrce
		   p.mrce.customskin = 2
		end   
    end
end)


addHook("PlayerThink",  function(p)
	if p.mo and p.mo.valid
		if p.mo.skin == "altknux"
			if p.altkmusic1 == nil
				p.altkmusic1 = true
			end
			if p.altkmusic2 == nil
				p.altkmusic2 = false
			end
			if p.altkmusic3 == nil
				p.altkmusic3 = false
			end
			if p.altkmusic4 == nil
				p.altkmusic4 = false
			end
			if p.altkmusic5 == nil
				p.altkmusic5 = false
			end			
		end
	end
end)

	
addHook("AbilitySpecial", function(player)
	if (player.mo.skin == "altknux") then
		if not (player.pflags & PF_THOKKED)
		and (player.playerstate == PST_LIVE)
		and not (player.powers[pw_carry])
		and not (player.mo.state == S_PLAY_PAIN)
		and not (player.mo.state == S_PLAY_DEAD)
		and not (player.mo.state == S_PLAY_DRWN)
		and not player.powers[pw_carry]
	    and not (player.climbing or player.mo.state == S_PLAY_CLING or player.mo.state == S_PLAY_CLIMB)
		and not (player.mo.state >= S_PLAY_SUPER_TRANS1 and player.mo.state <= S_PLAY_SUPER_TRANS6)
		   player.mo.state = S_PLAY_DIVE
		   player.stomp = false
	       P_SetObjectMomZ(player.mo, 14*FRACUNIT)
		   if (player.mo.eflags & MFE_UNDERWATER)
		   	   P_SetObjectMomZ(player.mo, 12*FRACUNIT)
		   end
		   S_StartSound(player.mo, sfx_kc3c)
		   player.pflags = $1|PF_THOKKED
		end
	end
end)


addHook("SpinSpecial", function(player)
	if (player.mo.skin == "altknux") then
	    if (player.mo.state == S_PLAY_JUMP)
		and (player.playerstate == PST_LIVE)
		and not (player.powers[pw_carry])
		and not (player.mo.state == S_PLAY_PAIN)
		and not (player.mo.state == S_PLAY_DEAD)
		and not (player.mo.state == S_PLAY_DRWN)
		and not (player.climbing or player.mo.state == S_PLAY_CLING or player.mo.state == S_PLAY_CLIMB)
		and not (player.mo.state >= S_PLAY_SUPER_TRANS1 and player.mo.state <= S_PLAY_SUPER_TRANS6)
		   player.mo.state = S_AIRPUNCH
		   player.stomp = false
	       P_Thrust(player.mo, player.mo.angle, 5*FRACUNIT)
		   S_StartSound(player.mo, sfx_punch)
	       local thokeffect = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_THOK)
	       thokeffect.fuse = 7
	       thokeffect.state = S_FACESTABBERSPEAR
	       thokeffect.angle = player.drawangle+ANGLE_90
	       thokeffect.scale = player.mo.scale/2+FRACUNIT/4
	       thokeffect.color = player.mo.color
	       thokeffect.colorized = true
	    if player.powers[pw_super]
		and player.knuxhypertrans
		   thokeffect.color = (SKINCOLOR_HYPER1 + abs(((player.powers[pw_super] >> 2) % 9) - 6))
		end	
		   thokeffect.colorized = true
		end
	end
end)


addHook("PlayerThink", function(player)
	if (player.mo.skin == "altknux") then
	    if (P_IsObjectOnGround(player.mo))
	    and (player.cmd.buttons & BT_SPIN)
		and (player.playerstate == PST_LIVE)
        and not player.weapondelay
	    and not player.exiting
	       S_StartSound(player.mo, sfx_punch)
		   player.weapondelay = 1*TICRATE/2
		   player.mo.state = S_PUNCH
		   player.pflags = $ & ~PF_SPINNING
		   P_Thrust(player.mo, player.mo.angle, 7*FRACUNIT)
		   player.mo.punch = 1
	       local thokeffect = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_THOK)
	       thokeffect.fuse = 7
	       thokeffect.state = S_FACESTABBERSPEAR
	       thokeffect.angle = player.drawangle+ANGLE_90
	       thokeffect.scale = player.mo.scale/2+FRACUNIT/4
	       thokeffect.color = player.mo.color
	       thokeffect.colorized = true
	    if player.powers[pw_super]
		and player.knuxhypertrans
		   thokeffect.color = (SKINCOLOR_HYPER1 + abs(((player.powers[pw_super] >> 2) % 9) - 6))
		end	
		   thokeffect.colorized = true
		end
	end
end)


addHook("PlayerCanDamage", function(player)
	if (player.mo.skin == "altknux")
	and (player.mo.state == S_PLAY_ROLL)
		return true
	end
end)


addHook("PlayerCanDamage", function(player)
	if (player.mo.skin == "altknux")
	and (player.mo.state == S_PUNCH)
		return true
	end
end)


addHook("PlayerThink", function(p)
	if (p.mo.skin == "altknux")
	and (p.pflags & PF_SPINNING)
	and (p.pflags & PF_JUMPED)
		p.pflags = $ & ~PF_SPINNING
	end
end)


addHook("PlayerThink", function(player)
	if player.mo then
		if player.mo.skin == "altknux" then
			if player.cmd.buttons & BT_CUSTOM3
			and P_IsObjectOnGround(player.mo)
			and (player.playerstate == PST_LIVE)
			and player.mo.state ~= S_PLAY_ALTKLAUGH then
				player.mo.state = S_PLAY_ALTKLAUGH
				player.mo.momx = 0*FRACUNIT
				player.mo.momy = 0*FRACUNIT
				player.mo.momz = 0*FRACUNIT
				S_StartSound(player.mo, sfx_laugh)
			end
			
			if player.mo.state == S_PLAY_ALTKLAUGH then
				player.powers[pw_nocontrol] = 1
			end
		else
			if player.mo.state == S_PLAY_ALTKLAUGH then
				player.mo.state = S_PLAY_STND
			end
		end
	end
end)


//taken from the pins of the srb2 offical server scipting channel thanks tasurtu
local function CheckAndCrumble(mo, sec)
  for fof in sec.ffloors()
    if not (fof.flags & FF_EXISTS) continue end -- Does it exist?
    if not (fof.flags & FF_BUSTUP) continue end -- Is it bustable?
    
    if mo.z + mo.height < fof.bottomheight continue end -- Are we too low?
    if mo.z > fof.topheight continue end -- Are we too high?

    -- Check for whatever else you may want to    

    EV_CrumbleChain(fof) -- Crumble
  end
end


addHook("PlayerThink", function(p)
	if (p.mo.skin == "altknux")
	    if (p.mo.state == S_PLAY_JUMP)
	    and (p.cmd.buttons & BT_CUSTOM1)
		and not (p.mo.state == S_PLAY_PAIN)
		and not (p.mo.state == S_PLAY_DEAD)
		and not (p.mo.state == S_PLAY_DRWN)
		and not (p.powers[pw_justsprung] or p.mo.eflags & MFE_SPRUNG or p.mo.eflags & MFE_GOOWATER)
			p.stomp = true
			p.mo.state = S_PLAY_DIVEDOWN
			P_SetObjectMomZ(p.mo, -40*FRACUNIT)
			S_StartSound(p.mo, sfx_kc3c)
		end
		if p.stomp
		and (p.mo.eflags & MFE_GOOWATER)
			p.stomp = false
			p.mo.state = S_PLAY_FALL
		end	
	end	
end)

		
addHook("PlayerThink", function(p)
	if (p.mo.skin == "altknux")	
		if (p.stomp)
        and (p.mo.eflags & MFE_JUSTHITFLOOR)
		and not (p.powers[pw_super])		
		and not (p.powers[pw_carry])
		and not (P_PlayerInPain(p))
		   p.stomp = false
		   p.mo.momx = 0
		   p.mo.momy = 0
		   CheckAndCrumble(p.mo, p.mo.subsector.sector)
		   p.mo.state = S_PLAY_GLIDE_LANDING
		   P_SetObjectMomZ(p.mo, 0*FRACUNIT)
		   S_StartSound(p.mo, sfx_s3k4c)
		end
		if (p.stomp)
        and (p.mo.eflags & MFE_JUSTHITFLOOR)
		and (p.powers[pw_super])		
		and not (p.powers[pw_carry])
		and not (P_PlayerInPain(p))
		   p.stomp = false
		   p.mo.momx = 0
		   p.mo.momy = 0
		   CheckAndCrumble(p.mo, p.mo.subsector.sector)
		   p.mo.state = S_PLAY_GLIDE_LANDING
		   P_SetObjectMomZ(p.mo, 0*FRACUNIT)
		   P_StartQuake(15*FRACUNIT, 11)
		   P_NukeEnemies(p.mo, p.mo, 1100*FRACUNIT)
		   S_StartSound(p.mo, sfx_s3k49)
		end
	end	
end)


addHook("PlayerThink", function(p)
	if p.mo.skin == "altknux"
	and (p.powers[pw_justsprung] or p.mo.eflags & MFE_SPRUNG)
	and (p.mo.state == S_PLAY_SPRING or p.mo.state == S_PLAY_FALL)
		p.sprong = true
	elseif P_IsObjectOnGround(p.mo)
		p.sprong = false
	end
	if (p.stomp)
	and (p.powers[pw_justsprung] or p.mo.eflags & MFE_SPRUNG)
	and not (p.powers[pw_underwater])
		p.stomp = false
		S_StopSoundByID(p.mo, sfx_spring)
		S_StartSound(p.mo, sfx_sprong)
		p.mo.momz = $*5/4
	end
	if (p.stomp)
	and (p.powers[pw_justsprung] or p.mo.eflags & MFE_SPRUNG)
	and (p.powers[pw_underwater])
		p.stomp = false
		S_StopSoundByID(p.mo, sfx_spring)
		S_StartSound(p.mo, sfx_sprong)
		p.mo.momz = $*5/4
	end   
	if (P_IsObjectOnGround(p.mo) or (p.mo.eflags & MFE_JUSTHITFLOOR))
	and (p.stomp)
		p.stomp = false
	end
	if (p.stomp)
	and (p.mo.eflags & MFE_GOOWATER)
		p.stomp = false
	end
	if (p.stomp)
	and (p.powers[pw_carry])
		p.stomp = false   
	end
end)

		   
addHook("PlayerThink", function(player)
	if player.mo.skin == "altknux"
	and P_IsObjectOnGround(player.mo)
	and (player.cmd.buttons & BT_CUSTOM2)
	and player.speed > 5*FRACUNIT
	and not (player.pflags & PF_SPINNING)
	    player.pflags = $ | PF_SPINNING
	end
end)


addHook("PlayerThink", function(player)	
	if (player.mo.skin == "altknux")
	and (player.pflags & PF_SPINNING)
	and (P_IsObjectOnGround(player.mo))
	    player.mo.state = S_PLAY_GLIDE
	    S_StartSound(player.mo, sfx_s3k7e)
		P_SpawnSkidDust(player, 13*FRACUNIT, sfx_none)
	end
end)


// Others \\


addHook("PlayerThink", function(p)	
	if leveltime % 5 == 0 then
		if p.powers[pw_super]
		and p.mo.skin == "altknux"
			local altksparkle = P_SpawnMobjFromMobj(p.mo, FRACUNIT*P_RandomRange(-16,16), FRACUNIT*P_RandomRange(-16,16), FixedDiv(p.mo.height/2,p.mo.scale)+(P_RandomRange(-16,16)*FRACUNIT), MT_ALTKSPARKLES)
			altksparkle.scale = p.mo.scale/3*2
			altksparkle.momz = FixedMul(FRACUNIT*2, p.mo.scale)*P_MobjFlip(p.mo)
	        altksparkle.source = p.mo
			altksparkle.color = p.mo.color
		if p.powers[pw_super]
		and p.knuxhypertrans
			altksparkle.color = (SKINCOLOR_HYPER1 + abs(((p.powers[pw_super] >> 2) % 9) - 6))
		end	
			altksparkle.colorized = true
		end	
	end
end)


addHook("PlayerThink", function(player)
	if leveltime % 2 == 0 then
		if (player.speed > 50*FRACUNIT)
		and player.mo.skin == "altknux"
	    and not (player.powers[pw_super])
			local strikesparkle = P_SpawnMobj(player.mo.x+P_RandomRange(-20, 20)*player.mo.scale, player.mo.y+P_RandomRange(-20, 20)*player.mo.scale, player.mo.z+P_RandomRange(0, -60)*player.mo.scale+player.mo.height, MT_ALTKSPARKLES)
			strikesparkle.flags2 = $|MF2_OBJECTFLIP
			strikesparkle.frame = $|FF_FULLBRIGHT
			strikesparkle.color = player.mo.color
			strikesparkle.colorized = true
			strikesparkle.momz = FixedMul(FRACUNIT*2, player.mo.scale)*P_MobjFlip(player.mo)
			strikesparkle.scale = player.mo.scale
	     end
	 end
end)


addHook("PlayerThink", function(p)
	if not (p.mo and p.mo.skin == "altknux") return end
    if (p.speed >= FixedMul(p.runspeed, p.mo.scale))
	and (p.cmd.forwardmove or p.cmd.sidemove)
	and not (p.xmomentum)
	and not (p.boostmentum)
		p.mo.friction = FRACUNIT
		p.charflags = $ & ~SF_NOSKID
	else
		p.mo.friction = 29*FRACUNIT/32
		p.charflags = $ & ~SF_NOSKID
	end	
end)


addHook("PlayerThink", function(p)
	if (p.mo.skin == "altknux") then
		if (FixedHypot(p.rmomx, p.rmomy)  >= 46*FRACUNIT)
		and (FixedDiv(p.mo.momz, p.mo.scale) == 0*FRACUNIT)
		and not (p.xmomentum)
		and not (p.boostmentum)
			p.charflags = $ | SF_RUNONWATER
		else
			p.charflags = $ & ~SF_RUNONWATER
		end
	end	
end)


addHook("PlayerCanDamage", function(p)
	if not (p.mo and p.mo.skin == "altknux") return end
	if (p.speed > 50*FRACUNIT)
	and not (p.xmomentum)
	and not (p.boostmentum) then
		return true
	end
end)


addHook("PlayerThink", function(p)
    if not (p.mo and p.mo.skin == "altknux") then return end
	if (p.cmd.buttons & BT_USE)
	and (p.mo.state == S_PLAY_SPRING or p.mo.state == S_PLAY_FALL)
	and not (p.exiting)
	and not (p.boostmentum)
	and not (p.powers[pw_shield] == SH_ELEMENTAL)
	and not (p.powers[pw_shield] == SH_WHIRLWIND)
	    S_StartSound(p.mo, sfx_spin)
	    p.mo.state = S_PLAY_ROLL
		p.stomp = false
		p.pflags = $|PF_JUMPED
	end
end)


addHook("PlayerThink", function(p)
    if (p.mo.skin == "altknux")
	and (p.playerstate == PST_LIVE)
	and not (p.mo.eflags & MFE_JUSTHITFLOOR)
	and not (p.pflags & PF_SPINNING)
		and not (p.powers[pw_carry] == CR_NIGHTSMODE)
	    and not (p.mrce)
	    if (p.mo.state == S_PLAY_STND) or (p.mo.state == S_PLAY_WAIT) or (p.mo.state == S_PLAY_WALK) or (p.mo.state == S_PLAY_RUN) or (p.mo.state == S_PLAY_DASH) then
		if ((p.mo.momz*P_MobjFlip(p.mo)) > 2*FRACUNIT)
			and not (p.mo.eflags & MFE_GOOWATER)
				p.mo.state = S_PLAY_SPRING
			elseif ((p.mo.momz*P_MobjFlip(p.mo)) < -2*FRACUNIT)
				p.mo.state = S_PLAY_FALL
			end
		end   
	end
end)


addHook("PlayerThink", function(player)	
	if (player.mo.skin == "altknux")
	and (player.mo.state == S_PLAY_RUN)
	and (P_IsObjectOnGround(player.mo))
	and not (player.powers[pw_super])
		P_SpawnSkidDust(player, 13*FRACUNIT, sfx_none)
	end
end)


addHook("PlayerThink", function(player)
    if not (player.mo.skin == "altknux") then return end
	if (player.speed > 50*FRACUNIT)
	and not (player.powers[pw_super])
		local gmobj = P_SpawnGhostMobj(player.mo)
		gmobj.fuse = 2
		gmobj.blendmode = AST_TRANSLUCENT
		gmobj.colorized = true
		if gmobj.tracer then gmobj.tracer.fuse = 2 end
		if (leveltime & 1)
			gmobj.frame = $&~FF_TRANSMASK
			gmobj.frame = $|tr_trans70<<FF_TRANSSHIFT
			if (gmobj.tracer)
				gmobj.tracer.frame = $&~FF_TRANSMASK
				gmobj.tracer.frame = $|tr_trans70<<FF_TRANSSHIFT
				gmobj.tracer.blendmode = AST_TRANSLUCENT
				gmobj.tracer.colorized = true
			end
		end
	end
end)


addHook("PlayerThink", function(player)
    if not (player.mo.skin == "altknux") then return end
	if (player.speed > 70*FRACUNIT)
	and not (player.powers[pw_super])
		local gmobj = P_SpawnGhostMobj(player.mo)
		gmobj.fuse = 3
		gmobj.blendmode = AST_TRANSLUCENT
		gmobj.colorized = true
		if gmobj.tracer then gmobj.tracer.fuse = 3 end
		if (leveltime & 1)
			gmobj.frame = $&~FF_TRANSMASK
			gmobj.frame = $|tr_trans70<<FF_TRANSSHIFT
			if (gmobj.tracer)
				gmobj.tracer.frame = $&~FF_TRANSMASK
				gmobj.tracer.frame = $|tr_trans70<<FF_TRANSSHIFT
				gmobj.tracer.blendmode = AST_TRANSLUCENT
				gmobj.tracer.colorized = true
			end
		end
	end
end)


// Hyper Form \\


COM_AddCommand("alt_hypermusic", function(p, arg)
	if arg == nil
		CONS_Printf(p, "Allows you to put any music on your Hyper Form")
		S_StartSound(nil, sfx_s3kad, p)
	elseif arg == "S&K" or arg == "1" then
		p.altkmusic1 = true
		p.altkmusic2 = false
		p.altkmusic3 = false
		p.altkmusic4 = false
		p.altkmusic5 = false		
		CONS_Printf(p, "The music is Sonic & Knuckles")
		S_StartSound(nil, sfx_s3k63, p)		
	elseif arg == "s3proto" or arg == "2" then
		p.altkmusic1 = false
		p.altkmusic2 = true
		p.altkmusic3 = false
		p.altkmusic4 = false
		p.altkmusic5 = false		
		CONS_Printf(p, "The music is Sonic 3 Prototype.")
		S_StartSound(nil, sfx_s3k63, p)
	elseif arg == "mania" or arg == "3" then
		p.altkmusic1 = false
		p.altkmusic2 = false
		p.altkmusic3 = true
		p.altkmusic4 = false
		p.altkmusic5 = false		
		CONS_Printf(p, "The music is Sonic Mania")
		S_StartSound(nil, sfx_s3k63, p)
	elseif arg == "superstars" or arg == "4" then
		p.altkmusic1 = false
		p.altkmusic2 = false
		p.altkmusic3 = false
		p.altkmusic4 = true
		p.altkmusic5 = false		
		CONS_Printf(p, "The music is Sonic Superstars")
	elseif arg == "forces" or arg == "5" then
		p.altkmusic1 = false
		p.altkmusic2 = false
		p.altkmusic3 = false
		p.altkmusic4 = false
		p.altkmusic5 = true		
		CONS_Printf(p, "The music is Sonic Forces")		
		S_StartSound(nil, sfx_s3k63, p)
	else CONS_Printf(p, "\x85"+"Invaild")
		S_StartSound(nil, sfx_notadd, p)
	end
end)


addHook("PlayerThink", function(player)
	if player.mo.skin == "altknux"
		if not (player.mo.knuxhyperform) then
	       player.mo.knuxhyperform = 0
	    end
		
		if (player.powers[pw_super])
		and (player.pflags & PF_JUMPED)
		and (player.cmd.buttons & BT_CUSTOM3)
		and not player.powers[pw_invulnerability] 
		and not player.powers[pw_flashing]
		and not (player.powers[pw_carry])
		and not (player.mo.state == S_PLAY_SUPER_TRANS1)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS2)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS3)
		and not (player.mo.state == S_PLAY_SUPER_TRANS4)
		and not (player.mo.state == S_PLAY_SUPER_TRANS5)
		and not (player.mo.state == S_PLAY_SUPER_TRANS6)
		and not (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT) 
		and player.mo.knuxhyperform == 0
		and (player.rings >= 100)
		and (player.powers[pw_shield] == SH_NONE or player.powers[pw_shield] == SH_FIREFLOWER)
			player.knuxhypertrans = true
			player.mo.knuxhyperform = 1
			P_DoSuperTransformation(player, true)
			S_StopSoundByID(nil, sfx_supert)
			S_StartSound(nil, sfx_s3k9f)
			player.keepspamming = true
			return false	
	    end
    end  
end)


addHook("PlayerThink", function(p)
	if p.mo.skin == "altknux"
		if (leveltime % 2 == 0)
		and p.keepspamming
			P_FlashPal(p, PAL_WHITE, 8)
			P_StartQuake(50*FRACUNIT, 10)
			P_NukeEnemies(p.mo, p.mo, 1536*FRACUNIT)
			p.stomp = false
		end
		if (p.mo.state == S_PLAY_SUPER_TRANS5)
			p.keepspamming = false
    	end
	end	
end)
		

addHook("PlayerThink", do
    for player in players.iterate
	    if (player.cmd.buttons & BT_CUSTOM2)
		and player.mo.skin == "altknux"
		and (player.pflags & PF_JUMPED)
		and not (player.powers[pw_carry])
		and not (player.mo.state == S_PLAY_SUPER_TRANS1)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS2)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS3)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS4)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS5)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS6)
		and (player.powers[pw_super])
		   player.powers[pw_super] = 0
		   P_RestoreMusic(player)
		   P_SpawnShieldOrb(player)
		   P_SpawnGhostMobj(player.mo)
		   player.mo.color = player.skincolor
		end
	end
end)


addHook("PlayerThink", function(player)
	if (player.mo.skin == "altknux")
	    if (player.speed >= FixedMul(player.runspeed, player.mo.scale))
	    and player.mo.knuxhyperform
           local hypertrail = P_SpawnGhostMobj(player.mo)
	       hypertrail.color = (SKINCOLOR_HYPER1 + abs(((player.powers[pw_super] >> 2) % 9) - 6))
           hypertrail.fuse = 4
	       hypertrail.rollangle = player.mo.rollangle
		end   
	end
end)


addHook("PlayerThink", function(p)
    if p.mo and p.mo.valid and p.mo.skin == "altknux" and p.knuxhypertrans
        if not p.musictune
			if p.altkmusic1
				P_PlayJingleMusic(p, "S&K", 0, true, JT_SUPER)
			elseif p.altkmusic2
				P_PlayJingleMusic(p, "PROTO", 0, true, JT_SUPER)
			elseif p.altkmusic3
				P_PlayJingleMusic(p, "MANIA", 0, true, JT_SUPER)
			elseif p.altkmusic4
				P_PlayJingleMusic(p, "SUPERSTARS", 0, true, JT_SUPER)
			elseif p.altkmusic5
				P_PlayJingleMusic(p, "FORCES", 0, true, JT_SUPER)
			end	
        end
        p.musictune = true
    else
        p.musictune = false
    end
end)


addHook("PlayerThink", function(p)
    if p.mo.knuxhyperform
		if (p.mo.eflags & MFE_UNDERWATER)
			p.powers[pw_underwater] = 100*TICRATE
		end
		if P_InSpaceSector(p.mo)
			p.powers[pw_spacetime] = 100*TICRATE
		end
	end
end)


addHook('PlayerThink', do
	for player in players.iterate
	    if player.mo and player.mo.valid
			if player.powers[pw_super] == 0
			or player.xmomentum
			player.mo.knuxhyperform = 0
			player.knuxhypertrans = false
			P_RestoreMusic(player)
		    player.mo.color = player.skincolor
		    player.normalspeed = skins[player.mo.skin].normalspeed
		end
	end 
end
end)


addHook("PlayerThink", function(p)
	local mo = p.mo
	
	if leveltime % 5 == 0 then
		if p.powers[pw_super]
		and p.knuxhypertrans
		and mo.skin == "altknux"
			local althypersparkle = P_SpawnMobjFromMobj(p.mo, FRACUNIT*P_RandomRange(-16,16), FRACUNIT*P_RandomRange(-16,16), FixedDiv(p.mo.height/2,p.mo.scale)+(P_RandomRange(-16,16)*FRACUNIT), MT_HYPERSPARKLES)
			althypersparkle.momx = P_RandomRange(-5, 5) * FRACUNIT
			althypersparkle.momy = P_RandomRange(-5, 5) * FRACUNIT
			althypersparkle.momz = FixedMul(FRACUNIT*2, p.mo.scale)*P_MobjFlip(p.mo)
			althypersparkle.scale = mo.scale/3*2
	        althypersparkle.source = mo
			althypersparkle.color = (SKINCOLOR_HYPER1 + abs(((p.powers[pw_super] >> 2) % 9) - 6))
			althypersparkle.colorized = true
		end	
	end
end)	


addHook("PlayerThink", function(p)
    if p.mo.skin == "altknux"
		if p.knuxhypertrans
		and not (p.mo.state == S_PLAY_SUPER_TRANS1)
	    and not (p.mo.state == S_PLAY_SUPER_TRANS2)
	    and not (p.mo.state == S_PLAY_SUPER_TRANS3)
			p.mo.color = (SKINCOLOR_HYPER1 + abs(((p.powers[pw_super] >> 2) % 9) - 6))
		end
	end
end)


addHook("PlayerThink", function(player)
	if (player.mo.knuxhyperform == 1) then
	    if (skins[player.mo.skin]) and (player.powers[pw_super])
		  and not (player.mo.skin == "altknux") then
			player.mo.knuxhyperform = 0
			player.knuxhypertrans = false
		end
	end
end)


// Hyper colors \\


// Red Starts

freeslot("SKINCOLOR_HYPER1")
skincolors[SKINCOLOR_HYPER1] = {
    name = "Iridescent Orange",
    ramp = {0,0,0,0,48,49,51,51,52,53,55,55,59,59,60,62},
    invcolor = SKINCOLOR_ORANGE,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}

// Blue

freeslot("SKINCOLOR_HYPER2")
skincolors[SKINCOLOR_HYPER2] = {
    name = "Iridescent Red",
    ramp = {0,0,0,0,208,209,32,32,33,34,36,36,42,42,43,45},
    invcolor = SKINCOLOR_ORANGE,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}

// Green

freeslot("SKINCOLOR_HYPER3")
skincolors[SKINCOLOR_HYPER3] = {
    name = "Iridescent Purple",
    ramp = {0,0,0,0,144,160,162,162,163,164,165,165,167,167,168,169},
    invcolor = SKINCOLOR_ORANGE,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}

// Yellow

freeslot("SKINCOLOR_HYPER4")
skincolors[SKINCOLOR_HYPER4] = {
    name = "Iridescent Light Blue",
    ramp = {0,0,0,0,128,129,131,131,134,135,149,149,173,173,174,175},
    invcolor = SKINCOLOR_ORANGE,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}

// White

freeslot("SKINCOLOR_HYPER5")
skincolors[SKINCOLOR_HYPER5] = {
    name = "Iridescent Green",
    ramp = {0,0,0,0,80,88,96,96,97,98,113,113,115,115,116,117},
    invcolor = SKINCOLOR_ORANGE,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}

// Violet

freeslot("SKINCOLOR_HYPER6")
skincolors[SKINCOLOR_HYPER6] = {
    name = "Iridescent Yellow",
    ramp = {0,0,0,0,80,81,83,72,74,74,75,75,76,76,67,68},
    invcolor = SKINCOLOR_ORANGE,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}

// Red ending

freeslot("SKINCOLOR_HYPER7")
skincolors[SKINCOLOR_HYPER7] = {
    name = "Iridescent White",
    ramp = {0,0,1,1,2,2,3,3,3,4,4,5,5,6,6,7},
    invcolor = SKINCOLOR_ORANGE,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}